﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Lab1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        Texture2D sprite;

        int width;
        int height;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            width = graphics.PreferredBackBufferWidth = 800;
            height = graphics.PreferredBackBufferHeight = 600;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
            sprite = Content.Load<Texture2D>("hero");
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
            // Координаты левого верхнего угла экрана
            Vector2 pos = new Vector2(0, 0);

            if (gameTime.TotalGameTime.TotalSeconds > 1)
            {
                // Координаты правого верхнего угла экрана
                // Для того, чтобы спрайт был виден на экране нужно сопоставить правый верхний угол изображения с правым верхним углом экрана
                pos = new Vector2(width - sprite.Width, 0);
            }
            if (gameTime.TotalGameTime.TotalSeconds > 2)
            {
                // Координаты правого нижнего угла экрана
                // Для того, чтобы спрайт был виден на экране нужно сопоставить правый нижний угол изображения с правым нижним углом экрана
                pos = new Vector2(width - sprite.Width, height - sprite.Height);
            }
            if (gameTime.TotalGameTime.TotalSeconds > 3)
            {
                // Координаты левого нижнего угла экрана
                // Для того, чтобы спрайт был виден на экране нужно сопоставить левый нижний угол изображения с левым нижним углом экрана
                pos = new Vector2(0, height - sprite.Height);
            }
            if (gameTime.TotalGameTime.TotalSeconds > 4)
            {
                // Координаты цетра экрана
                // Координаты цетра спрайта вычисляются как (sprite.Width / 2; sprite.Height / 2)
                // Для того, чтобы центр спрайта совпал с центром экрана нужно выполнить следующие вычисления
                pos = new Vector2(width / 2 - sprite.Width / 2, height / 2 - sprite.Height / 2);
            }

            spriteBatch.Begin();
            spriteBatch.Draw(sprite, pos, Color.White);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
